#ifndef _INTERPRETER_H_
#define _INTERPRETER_H_

/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#define MS_BASE		-1
#define MS_STAT		0
#define MS_DYN		1
#define MS_JTAB		2
#define MS_SEG		3
#define MS_IPC		4
#define	MS_SP		5
#define MS_VAR		5
#define MS_FRAME_SIZE	6

#define JTAB_SEG_LEX	0
#define JTAB_ENTRY_IPC	-1
#define JTAB_EXIT_IPC	-2
#define JTAB_PARAM_SZ	-3
#define JTAB_DATA_SZ	-4

#define BYTE_ADDR( pointer, offset ) ((pointer) + (offset))
#define WORD_ADDR( pointer, offset ) ((pointer) + (2 * (offset)))

void stack_check();
void interpret();

#endif
