#ifndef _MEMORY_H_
#define _MEMORY_H_

/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#define WORD_SIZE	16
#define SET_SIZE	512

typedef byte mem_t;

#define MEM_SIZE	0x010000

typedef struct set
{
  word	size;
  word	data[ SET_SIZE / WORD_SIZE ];
} set_t;

void push_w( word w );
word pop_w();

void mem_wr_w( word addr, word w );
word mem_rd_w( word addr );

void mem_wr_b( word addr, byte b );
byte mem_rd_b( word addr );

void push_r( real w );
real pop_r();

void pop_s( set_t *set );
void push_s( set_t *set );

#endif
