/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#include "pme.h"
#include "boot.h"
#include "unit_io.h"
#include "interpreter.h"

int dflag = 0;

void useage( char *progname )
{
fprintf( stderr, "Usage %s: [DHh?] [-d <debug level>] [-c <config filename>]\n", progname );
fprintf( stderr, "\t-c <filename>    config filename\n" );
fprintf( stderr, "\t-D               debug\n" );
fprintf( stderr, "\t-d <debug level> debug\n" );
fprintf( stderr, "\t-H               help, you are reading it\n" );
fprintf( stderr, "\t-h               help, you are reading it\n" );
fprintf( stderr, "\t-?               help, you are reading it\n" );
fprintf( stderr, "\n" );
}

int main( int argc, char **argv )
{
int c;
int errflag = 0;
int hflag = 0;
char *config_filename = ".psystem";

char *progname;

extern char *optarg;
extern int optind;

/* First get the program name */
progname = (char *) strrchr( argv[ 0 ], '/' );
if ( progname == NULL )
	progname = argv[ 0 ];
else
	progname++;

while( ( c = getopt( argc, argv, "Dd:Hh?c:" ) ) != EOF )
	switch ( c )
	{
	case( 'D' ):	dflag++;
			break;
	case( 'd' ):	dflag = atoi( optarg );
			break;
	case( 'c' ):	config_filename = optarg;
			break;
	case( 'H' ):
	case( 'h' ):
	case( '?' ):	hflag++;
			break;
	default:
			break;
	}

if ( hflag || errflag )
	{
	useage( progname );
	return ( 1 );
	}

init_unit_io( config_filename );
if ( boot_system_pascal() == 0 )
	interpret();
halt_unit_io();

return( 0 );
}
