#ifndef _UCSD_CONSTS_H_
#define _UCSD_CONSTS_H_

/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#define UCSD_BLKSZ	512

#define MAX_UNITS	16

#define NIL		1

#define MAXSEG		15

#define CSP_IOC		0	/* iocheck() */
#define CSP_NEW		1	/* new() */
#define CSP_MVL		2	/* moveleft() */
#define CSP_MVR		3	/* moveright() */
#define CSP_XIT		4	/* exit() */
#define CSP_UREAD	5	/* unitread() */
#define CSP_UWRITE	6	/* unitwrite() */
#define CSP_IDS		7	/* idsearch() */
#define CSP_TRS		8	/* treesearch() */
#define CSP_TIM		9	/* time() */
#define CSP_FLC		10	/* fillchar() */
#define CSP_SCN		11	/* scan() */
#define CSP_USTAT	12	/* unitstat() */
#define CSP_LDSEG	21	/* loadsegment() */
#define CSP_ULDSEG	22	/* unloadsegment() */
#define CSP_TRC		23	/* trunc() */
#define CSP_RND		24	/* round() */
#define CSP_SIN		25	/* sine */
#define CSP_COS		26	/* cosine */
#define CSP_LOG		27	/* log 10 */
#define CSP_ATAN	28	/* arctan */
#define CSP_LN		29	/* log N */
#define CSP_EXP		30	/* exp */
#define CSP_SQT		31	/* sqr root */
#define CSP_MRK		32	/* mark() */
#define CSP_RLS		33	/* release() */
#define CSP_IOR		34	/* ioresult() */
#define CSP_UBUSY	35	/* unitbusy() */
#define CSP_POT		36	/* pwroften() */
#define CSP_UWAIT	37	/* unitwait() */
#define CSP_UCLEAR	38	/* unitclear() */
#define CSP_HLT		39	/* halt() */
#define CSP_MAV		40	/* memavail() */

#define ENOERR		0
#define EINVNDX		1
#define ENOPROC		2
#define ENOEXIT		3
#define ESTKOVR		4
#define EINTOVR		5
#define EDIVZER		6
#define ENILPTR		7
#define EUBREAK		8
#define ESYIOER		9
#define EUIOERR		10
#define ENOTIMP		11
#define EFLOAT		12
#define ES2LONG		13
#define EHALT		14
#define EBRKPNT		15
#define ESTKUDR		16
#define EADJFAIL	0

#endif
