#ifndef _UCSD_SYSCOM_H_
#define _UCSD_SYSCOM_H_

/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

struct mscw
	{
	word static_link;
	word dynamic_link;
	word msjtab;
	word msseg;
	word msipc;
	word localdata;
	} ;

struct crtctl_rec
	{
	/* output to CONSOLE: */
	byte esc;		/* escape */
	byte home;		/* [EM] - home */
	byte eraseeos;		/* [VT] - eraseeos */
	byte eraseeol;		/* [GS] - eraseeol */
	byte ndfs;		/* [FS] - non-destructive forward space */
	byte rlf;		/* [US] - reverse line feed */
	byte bs;		/* [BS] - backspace */
	byte fc;		/* fillcount */
	byte clearline;		/* clear line */
	byte clearscreen;	/* clear screen */
	word prefixed;		/* packed array 0 .. 8 of boolean */
	} ;

struct crtinfo_rec
	{
	word height;		/* height */
	word width;		/* width */
	/* input from CONSOLE: */
	byte up;		/* [US] - up */
	byte down;		/* [LF] - down */
	byte left;		/* [BS] - left */
	byte right;		/* [FS] - right */
	byte syeof;		/* ^C */
	byte flush;		/* ^F */
	byte break_ch;		/* */
	byte stop;		/* ^S */
	byte chardel;		/* ^H - chardel */
	byte badch;		/* ? - badch */
	byte linedel;		/* [del] - linedel */
	byte altmode;		/* [esc] - altmode */
	byte prefix;		/* */
	byte etx;		/* */
	byte backspace;		/* */
	byte X1;		/* */
	word prefixed;		/* packed array 0 .. 13 of boolean */
	} ;

struct int_seg_entry
	{
	word ref_count;
	word code_addr;
	} ;

struct disk_seg_entry
	{
	word disk_addr;
	word code_len;
	} ;

struct syscom_seg_entry
	{
	word code_unit;
	word disk_addr;
	word code_len;
	} ;

struct syscom_rec
	{
	word iorslt;
	word xeqerr;
	word sysunit;
	word bugstate;
	word gdirp;
	word bombp;
	word stkbase;
	word lastmp;
	word jtab;
	word seg;
	word memtop;
	word bomipc;
	word hltline;
	word brkpts[ 4 ];
	word retries;
	word X1[ 9 ];
	word lotime;
	word hitime;
	word miscinfo;
	word crttype;
	struct crtctl_rec crtctl;
	struct crtinfo_rec crtinfo;
	struct syscom_seg_entry segtbl[ MAXSEG + 1 ];
	} ;

#endif
